scripts/createVhosts.sh

296 lines
6.2 KiB
Bash
Raw Normal View History

2021-03-17 16:10:32 -04:00
#!/bin/bash
2021-01-21 16:58:32 -05:00
#
# Create Vhosts on VPS3
#
2021-03-17 16:10:32 -04:00
#set -e
2021-01-21 16:58:32 -05:00
2021-02-17 11:24:46 -05:00
function usage
{
2021-01-21 16:58:32 -05:00
echo "Usage: ${0}"
echo " --domain domain.tld"
echo " Domain to use when creating vhost"
2021-02-17 11:24:46 -05:00
echo " --root /var/www/html"
echo " Root directory of this vhost"
2021-03-17 17:47:19 -04:00
echo " --backend http://127.0.0.1"
2021-02-17 11:24:46 -05:00
echo " Hostname of the backend server to pass traffic to"
2021-03-17 17:47:19 -04:00
echo " Note: Do not specify a port"
2021-01-21 16:58:32 -05:00
echo " --listenip x.x.x.x"
echo " IP to bind to when listening"
echo " --desc x.x.x.x"
echo " Description of VHosts"
echo " -h | --help"
echo " Show this usage"
exit 0
}
function get_cert
{
2021-03-19 11:48:38 -04:00
# should we enable verbose
_debug_arg=""
if [ "$DEBUG" = "1" ]; then
_debug_arg="--debug"
fi
/root/.acme.sh/acme.sh --issue --domain $_domain --webroot /srv/http-content-combined/ --cert-file /etc/nginx/ssl/${_domain}.crt --key-file /etc/nginx/ssl/${_domain}.key --fullchain-file /etc/nginx/ssl/${_domain}-fullchain.crt $_debug_arg
return $?
2021-01-21 16:58:32 -05:00
}
2021-02-17 12:47:48 -05:00
function reload_nginx
{
echo -n "Reloading Nginx..."
if systemctl reload nginx; then
echo "Success"
else
echo "Failed"
fi
# Wait for nginx to reload
sleep 0.5
}
2021-03-24 16:39:37 -04:00
function clean_up
{
debug "Removing Nginx configuration and logs..."
rm $_vhost_conf_file
rm /var/log/nginx/$_domain.*
reload_nginx
err $1
}
function verify_vhost
{
local target=127.0.0.1
local verify_path=/srv/http-content-combined/.well-known/
local verify_file_name=verify.$_domain.html
local verify_full_path=$verify_path$verify_file_name
local http_resp
if test -n "$_listenip"; then
target=$_listenip
fi
mkdir -p $verify_path
touch $verify_full_path
http_resp=$(curl -I -H "Host: $_domain" http://$target/.well-known/$verify_file_name 2> /dev/null | grep 'HTTP/1.1 200 OK')
rm $verify_full_path
if test -z "$http_resp"; then
return 1
else
return 0
fi
}
2021-01-21 16:58:32 -05:00
_cwd="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
_bootstrap=${_cwd}/bootstrap.sh
2021-03-17 16:10:32 -04:00
_bb_myname=$(basename "$0")
_bb_mypath=$(realpath $BASH_SOURCE)
2021-01-21 16:58:32 -05:00
# Init script
2021-02-17 11:24:46 -05:00
if test -f $_bootstrap; then
source $_bootstrap 2> /dev/null
else
echo "Unable to parse BOOTSTRAP: $_bootstrap"
exit 1
2021-01-21 16:58:32 -05:00
fi
2021-03-17 17:59:23 -04:00
# gain priviledges
become "$@"
2021-03-17 17:47:19 -04:00
OPTS=$(getopt -o h -l domain:,root:,backend:,listenip:,desc:,donotredirect -n 'createVhosts' -- "$@")
2021-01-21 16:58:32 -05:00
if [ "$?" -gt '0' ]; then
echo 'Failed to set command line arguments'
exit 1;
fi
eval set -- "$OPTS"
_domain=false
2021-03-17 17:47:19 -04:00
_donotredirect=false
2021-02-17 11:24:46 -05:00
_root=""
_backend=""
_listenip=""
2021-01-21 16:58:32 -05:00
while true; do
case "$1" in
--domain )
_domain=$2
shift ;;
2021-02-17 11:24:46 -05:00
--root )
_root=$2
shift ;;
--backend )
_backend=$2
2021-01-21 16:58:32 -05:00
shift ;;
--listenip )
_listenip=$2
shift ;;
--desc )
_desc=$2
shift ;;
2021-03-17 17:47:19 -04:00
--donotredirect )
_donotredirect=true
shift ;;
2021-01-21 16:58:32 -05:00
-h | --help ) usage; shift ;;
-- ) shift; break ;;
* ) shift;;
esac
done
if [[ $_domain = false ]]; then
err "You must set domain"
fi
2021-02-17 11:24:46 -05:00
if test -n "$_root"; then
echo -n "Checking if $_root exists?"
2021-02-17 11:24:46 -05:00
if ! test -d $_root; then
2021-03-17 16:10:32 -04:00
echo " Creating..."
mkdir -p $_root
else
echo " Yes!"
2021-02-17 11:24:46 -05:00
fi
_rootpath="root $_root;"
fi
2021-03-17 17:47:19 -04:00
_check_host=success
_locationblock_http=""
_locationblock_https=""
2021-02-17 11:24:46 -05:00
if test -n "$_backend"; then
2021-03-17 17:47:19 -04:00
echo "Verifying backend(s)..."
_https_backend=$(echo $_backend | sed 's/http/https/')
if validate_host $_https_backend:443; then
#<<<<<<HEREDOC
_locationblock_https=$(cat <<- EOF
proxy_pass $_https_backend:443;
include proxy_params;
EOF
)
#<<<<<<HEREDOC
else
_check_host=failed
2021-02-17 11:24:46 -05:00
fi
2021-03-17 17:47:19 -04:00
# Include backend for HTTP traffic if donotredirect is enabled
#
if [ "$_donotredirect" = "true" ]; then
_http_backend=$(echo $_backend | sed 's/https/http/')
if validate_host $_http_backend:80; then
#<<<<<<HEREDOC
_locationblock_http=$(cat <<- EOF
proxy_pass $_http_backend:80;
2021-02-17 11:24:46 -05:00
include proxy_params;
EOF
)
2021-03-17 17:47:19 -04:00
#<<<<<<HEREDOC
else
_check_host=failed
fi
fi
if [ "$_check_host" = "failed" ]; then
err "Invalid hostname: $_backend. Not resolvable!"
fi
2021-02-17 11:24:46 -05:00
fi
if test -n "$_listenip"; then
if ! validate_ip $_listenip; then
err "Invalid IP: $_listenip"
fi
_listenip="$_listenip:"
else
2021-03-17 16:10:32 -04:00
warn "Listen ip not specified, listening on all interfaces."
2021-01-21 16:58:32 -05:00
fi
2021-02-17 11:24:46 -05:00
if test -z "$_root" -a -z "$_backend"; then
err "You must specify either --root or --backend!"
2021-01-21 16:58:32 -05:00
fi
echo -n "Checking if /srv/http-content-combined/ exists?"
if ! test -d /srv/http-content-combined; then
echo " Creating..."
mkdir -p /srv/http-content-combined/
else
echo " Yes!"
fi
2021-03-17 17:47:19 -04:00
echo -n "Checking if we should redirect?"
if [ "$_donotredirect" = "false" ]; then
echo " Yes, enabling redirect!"
_locationblock_http=" return 302 https://${_domain}\$request_uri;"
else
echo " No!"
fi
2021-02-17 12:47:48 -05:00
_vhost_conf_file=/etc/nginx/conf.d/${_domain}.conf
echo -n "Checking if $_vhost_conf_file exists? "
if test -f $_vhost_conf_file; then
echo "Removing!"
rm $_vhost_conf_file
else
echo "No!"
fi
2021-03-17 16:10:32 -04:00
echo "Creating Nginx configuration..."
2021-01-21 16:58:32 -05:00
cat << EOF > $_vhost_conf_file
#### Description
## Type: HTTP
## VHost: $_domain
## $_desc
server {
2021-02-17 11:24:46 -05:00
listen ${_listenip}80;
2021-01-21 16:58:32 -05:00
server_name $_domain;
2021-02-17 11:24:46 -05:00
2021-03-19 11:42:32 -04:00
error_log /var/log/nginx/${_domain}.error.log;
access_log /var/log/nginx/${_domain}.access.log main;
2021-01-21 16:58:32 -05:00
location /.well-known {
root /srv/http-content-combined/;
2021-01-21 16:58:32 -05:00
autoindex on;
}
2021-02-17 11:24:46 -05:00
2021-01-21 16:58:32 -05:00
location / {
2021-03-17 17:47:19 -04:00
$_locationblock_http
2021-01-21 16:58:32 -05:00
}
}
2021-02-17 12:47:48 -05:00
EOF
echo "Setting permissions on conf file..."
setfacl -m user:sysadmin:rw $_vhost_conf_file
reload_nginx
echo "Verifying vhost..."
if ! verify_vhost; then
2021-03-24 16:39:37 -04:00
clean_up "Failed to verify vhost"
fi
2021-02-17 12:47:48 -05:00
echo "Retrieving Let's Encrypt Certificate..."
if ! get_cert; then
2021-03-24 16:39:37 -04:00
clean_up "Failed to retrieve certificate!"
fi
2021-02-17 12:47:48 -05:00
cat << EOF >> $_vhost_conf_file
2021-01-21 16:58:32 -05:00
server {
2021-02-17 11:24:46 -05:00
listen ${_listenip}443 http2 ssl;
2021-01-21 16:58:32 -05:00
server_name $_domain;
2021-02-17 11:24:46 -05:00
$_rootpath
2021-01-21 16:58:32 -05:00
error_log /var/log/nginx/${_domain}.error.log;
access_log /var/log/nginx/${_domain}.access.log main;
2021-02-17 11:24:46 -05:00
2021-01-21 16:58:32 -05:00
ssl_certificate ssl/${_domain}-fullchain.crt;
ssl_certificate_key ssl/${_domain}.key;
2021-02-17 11:24:46 -05:00
2021-01-21 16:58:32 -05:00
location / {
2021-03-17 17:47:19 -04:00
${_locationblock_https}
2021-01-21 16:58:32 -05:00
}
}
EOF
2021-02-17 12:47:48 -05:00
reload_nginx